"
    Copyright (C) 2015-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.
"
"{ Package: 'jv:llvm_s' }"

"{ NameSpace: Smalltalk }"

ExternalBytes variableByteSubclass:#LLVMMCJITCompilerOptions
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'LLVM-S-Core'
!

!LLVMMCJITCompilerOptions class methodsFor:'documentation'!

copyright
"
    Copyright (C) 2015-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.
"
! !

!LLVMMCJITCompilerOptions class methodsFor:'accessing'!

new
    ^ self new: self sizeof

    "Created: / 08-02-2016 / 13:53:21 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

new: size
    | options |
    self assert: size == self sizeof.
    options := super new: size.
    LLVM InitializeMCJITCompilerOptions: options _: size.
    ^ options

    "Created: / 08-02-2016 / 13:53:50 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

sizeof
    "Returns size of undelaying structure in bytes"

    ^24
! !

!LLVMMCJITCompilerOptions methodsFor:'accessing'!

CodeModel
    "Returns ;; Line: 3682
(enum LLVMCodeModel
	(value (LLVMCodeModelDefault) 0)
	(value (LLVMCodeModelJITDefault) 1)
	(value (LLVMCodeModelSmall) 2)
	(value (LLVMCodeModelKernel) 3)
	(value (LLVMCodeModelMedium) 4)
	(value (LLVMCodeModelLarge) 5) )"

    ^self doubleWordAt:1 + 4
!

CodeModel: value

    self doubleWordAt:1 + 4 put:value
!

EnableFastISel
    "Returns ;; Line: 1141
(typedef 
	LLVMBool
		bool)"

    ^self at:1 + 12
!

EnableFastISel: value

    self at:1 + 12 put:value
!

MCJMM
    "Returns ;; Line: 3675
(typedef 
        LLVMMCJITMemoryManagerRef
                (pointer-to ;; Line: 4082
;; Class: LLVMOpaqueMCJITMemoryManager
))"

    ^self pointerAt:1 + 16

    "Modified: / 08-02-2016 / 13:57:06 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

MCJMM: value
    self pointerAt:1 + 16 put:value

    "Modified: / 08-02-2016 / 13:57:18 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

NoFramePointerElim
    "Returns ;; Line: 1141
(typedef 
	LLVMBool
		bool)"

    ^self at:1 + 8
!

NoFramePointerElim: value

    self at:1 + 8 put:value
!

OptLevel
    "Returns unsigned int"

    ^self longAt:1 + 0
!

OptLevel: value

    self longAt:1 + 0 put:value
! !

